#include <OI/oi.H>
#include <ctype.h>

main (int argc, char **argv)
{
	OI_ef_char_chk_status hexValidate(OI_entry_field *, void *, OI_number, char);	/*  validation routine */
	OI_connection	*conp;				/* the connection to the server */
	OI_app_window	*appWindow;			/* the enclosing app window */
	OI_entry_field	*entryField;			/* the entry field */

	if ((conp = OI_init(&argc, argv, "callback", "Callback"))) {
		appWindow = oi_create_app_window("myapp", 10, 10, "C callback");
		appWindow->set_layout(OI_layout_row);

		entryField = oi_create_entry_field("hexEntry", 8, "Address: 0x", NULL, 8);
		entryField->set_char_chk(hexValidate);
		entryField->layout_associated_object(appWindow, 0, 0, OI_ACTIVE);

		appWindow->set_associated_object(conp->root(), OI_DEF_LOC, OI_DEF_LOC, OI_ACTIVE);

		OI_begin_interaction();
	}
	OI_fini();
}

OI_ef_char_chk_status
hexValidate(OI_entry_field *, void *, OI_number, char c)
{
	OI_ef_char_chk_status ok;

	ok = OI_EF_CHAR_CHK_BAD;
	if (c && isxdigit(c))
		ok = OI_EF_CHAR_CHK_INSERT;

	return (ok);
}