#include <OI/oi.H> /*** keyhelp.C ***/

 main(int argc, char**argv)
{
			int		key_callback(OI_d_tech*,void*) ;
			OI_connection	*conp ;
			OI_app_window	*wp ;
			OI_static_text	*tp ;

	if (conp=OI_init(&argc,argv,"test")) {
		wp = oi_create_app_window("main",300,200,"Main") ;
		wp->set_layout(OI_layout_row) ;
		tp = oi_create_static_text("World","Hello, World!") ;
		tp->layout_associated_object(wp,0,0,OI_ACTIVE) ;
		tp = oi_create_static_text("Universe","Hello, Universe!") ;
		tp->layout_associated_object(wp,0,1,OI_ACTIVE) ;
		tp = oi_create_static_text("Query","Is anyone home?") ;
		tp->layout_associated_object(wp,0,2,OI_ACTIVE) ;
		wp->set_associated_object(wp->root(),OI_DEF_LOC,OI_DEF_LOC,OI_ACTIVE) ;
		wp->push_help("Hello","keyhelp.hp") ;
		wp->set_key_help(key_callback) ;
		OI_begin_interaction() ;
	}
}
 
 int key_callback(OI_d_tech *objp, void*)
{
			char		str[101] ;
			int		ret ;

	ret = 0 ;
	if (objp) {
		if (objp->name()) {
			if (objp->app_window()->set_help(objp->name()) == OI_OK) {
				sprintf(str,"Object under pointer is \"%s\"",objp->name()) ;
				ret = 1 ;
			}
			else
				sprintf(str,"Unable to set help context for \"%s\"",objp->name()) ;
			objp->set_help_str(str) ;
		}
		else
			objp->set_help_str("Object under pointer has no name") ;
	}
	return(ret) ;
}
